// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package apipb

import (
	context "context"
	empty "github.com/golang/protobuf/ptypes/empty"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion6

// LedgerClient is the client API for Ledger service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type LedgerClient interface {
	//*
	// Create a new ledger
	// 创建一个新账本
	CreateLedger(ctx context.Context, in *CreateLedgerRequest, opts ...grpc.CallOption) (*CreateLedgerResponse, error)
	//*
	// Get all ledgers
	// 查询所有帐本列表
	GetLedgers(ctx context.Context, in *empty.Empty, opts ...grpc.CallOption) (*GetLedgersResponse, error)
	//*
	// Send a new transaction
	// 发送一个新事务
	SendTransaction(ctx context.Context, in *SendTransactionRequest, opts ...grpc.CallOption) (*SendTransactionResponse, error)
}

type ledgerClient struct {
	cc grpc.ClientConnInterface
}

func NewLedgerClient(cc grpc.ClientConnInterface) LedgerClient {
	return &ledgerClient{cc}
}

func (c *ledgerClient) CreateLedger(ctx context.Context, in *CreateLedgerRequest, opts ...grpc.CallOption) (*CreateLedgerResponse, error) {
	out := new(CreateLedgerResponse)
	err := c.cc.Invoke(ctx, "/bdware.bdledger.api.Ledger/CreateLedger", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ledgerClient) GetLedgers(ctx context.Context, in *empty.Empty, opts ...grpc.CallOption) (*GetLedgersResponse, error) {
	out := new(GetLedgersResponse)
	err := c.cc.Invoke(ctx, "/bdware.bdledger.api.Ledger/GetLedgers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ledgerClient) SendTransaction(ctx context.Context, in *SendTransactionRequest, opts ...grpc.CallOption) (*SendTransactionResponse, error) {
	out := new(SendTransactionResponse)
	err := c.cc.Invoke(ctx, "/bdware.bdledger.api.Ledger/SendTransaction", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// LedgerServer is the server API for Ledger service.
type LedgerServer interface {
	//*
	// Create a new ledger
	// 创建一个新账本
	CreateLedger(context.Context, *CreateLedgerRequest) (*CreateLedgerResponse, error)
	//*
	// Get all ledgers
	// 查询所有帐本列表
	GetLedgers(context.Context, *empty.Empty) (*GetLedgersResponse, error)
	//*
	// Send a new transaction
	// 发送一个新事务
	SendTransaction(context.Context, *SendTransactionRequest) (*SendTransactionResponse, error)
}

// UnimplementedLedgerServer can be embedded to have forward compatible implementations.
type UnimplementedLedgerServer struct {
}

func (*UnimplementedLedgerServer) CreateLedger(context.Context, *CreateLedgerRequest) (*CreateLedgerResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateLedger not implemented")
}
func (*UnimplementedLedgerServer) GetLedgers(context.Context, *empty.Empty) (*GetLedgersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetLedgers not implemented")
}
func (*UnimplementedLedgerServer) SendTransaction(context.Context, *SendTransactionRequest) (*SendTransactionResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendTransaction not implemented")
}

func RegisterLedgerServer(s *grpc.Server, srv LedgerServer) {
	s.RegisterService(&_Ledger_serviceDesc, srv)
}

func _Ledger_CreateLedger_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateLedgerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LedgerServer).CreateLedger(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/bdware.bdledger.api.Ledger/CreateLedger",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LedgerServer).CreateLedger(ctx, req.(*CreateLedgerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Ledger_GetLedgers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(empty.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LedgerServer).GetLedgers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/bdware.bdledger.api.Ledger/GetLedgers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LedgerServer).GetLedgers(ctx, req.(*empty.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Ledger_SendTransaction_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendTransactionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LedgerServer).SendTransaction(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/bdware.bdledger.api.Ledger/SendTransaction",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LedgerServer).SendTransaction(ctx, req.(*SendTransactionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Ledger_serviceDesc = grpc.ServiceDesc{
	ServiceName: "bdware.bdledger.api.Ledger",
	HandlerType: (*LedgerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateLedger",
			Handler:    _Ledger_CreateLedger_Handler,
		},
		{
			MethodName: "GetLedgers",
			Handler:    _Ledger_GetLedgers_Handler,
		},
		{
			MethodName: "SendTransaction",
			Handler:    _Ledger_SendTransaction_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "bdware/bdledger/api/ledger.proto",
}
